
/*
 * vector.c
 *      Vector de reals.
 */

#include <assert.h>
#include <stdlib.h>

#include "vector.h"

/* Implementacio de les operacions */

Vector
CrearVector(int n)
{
    Vector v;

    assert(n > 0);
    v.dim = n;
    v.telem = (float *)malloc(n * sizeof (float));

    assert(v.telem != NULL);
    return v;
}

int
DimVector(Vector v)
{
    return v.dim;
}

void
AssigVector(Vector * const v, int i, float f)
{
    assert(0 <= i && i < (*v).dim);
    (*v).telem[i] = f;
}

float
ConsVector(Vector v, int i)
{
    assert(0 <= i && i <= v.dim);
    return v.telem[i];
}

void
DestruirVector(Vector * const v)
{
    free((*v).telem);
}
